searchNodes=[{"doc":"Module documentation for Shippex .","ref":"Shippex.html","title":"Shippex","type":"module"},{"doc":"Cancels the transaction associated with label , if possible. The result is returned in a tuple. You may pass in either the transaction, or if the full transaction struct isn't available, you may pass in the carrier, shipment, and tracking number instead. case Shippex . cancel_shipment ( transaction ) do { :ok , result } -&gt; IO . inspect ( result ) #=&gt; %{code: &quot;1&quot;, message: &quot;Voided successfully.&quot;} { :error , %{ code : code , message : message } } -&gt; IO . inspect ( code ) IO . inspect ( message ) end","ref":"Shippex.html#cancel_transaction/1","title":"Shippex.cancel_transaction/1","type":"function"},{"doc":"","ref":"Shippex.html#cancel_transaction/3","title":"Shippex.cancel_transaction/3","type":"function"},{"doc":"Fetches the label for shipment for a specific Service . The service module contains the Carrier and selected delivery speed. Shippex . create_transaction ( shipment , service )","ref":"Shippex.html#create_transaction/2","title":"Shippex.create_transaction/2","type":"function"},{"doc":"Fetches the rate for shipment for a specific Service . The service module contains the Carrier and selected delivery speed. You can also pass in the ID of the service. Shippex . fetch_rate ( shipment , service )","ref":"Shippex.html#fetch_rate/2","title":"Shippex.fetch_rate/2","type":"function"},{"doc":"Fetches rates for a given shipment . Possible options: carriers - Fetches rates for all services for the given carriers services - Fetches rates only for the given services These may be used in combination. To fetch rates for all UPS services, as well as USPS Priority, for example: Shippex . fetch_rates ( shipment , carriers : :ups , services : [ :usps_priority ] ) If no options are provided, Shippex will fetch rates for every service from every available carrier.","ref":"Shippex.html#fetch_rates/2","title":"Shippex.fetch_rates/2","type":"function"},{"doc":"Returns true if the carrier services the given country. An ISO-3166-compliant country code is required. iex&gt; Shippex . services_country? ( :usps , &quot;US&quot; ) true iex&gt; Shippex . services_country? ( :usps , &quot;KP&quot; ) false","ref":"Shippex.html#services_country?/2","title":"Shippex.services_country?/2","type":"function"},{"doc":"Performs address validation. If the address is completely invalid, {:error, result} is returned. For addresses that may have typos, {:ok, candidates} is returned. You can iterate through the list of candidates to present to the end user. Addresses that pass validation perfectly will still be in a list where length(candidates) == 1 . Note that the candidates returned will automatically pass through Shippex.Address.address() for casting. Also, if :usps is used as the validation provider, the number of candidates will always be 1. address = Shippex.Address . address ( %{ name : &quot;Earl G&quot; , phone : &quot;123-123-1234&quot; , address : &quot;9999 Hobby Lane&quot; , address_line_2 : nil , city : &quot;Austin&quot; , state : &quot;TX&quot; , postal_code : &quot;78703&quot; } ) case Shippex . validate_address ( address ) do { :error , %{ code : code , message : message } } -&gt; # Present the error. { :ok , candidates } when length ( candidates ) == 1 -&gt; # Use the address { :ok , candidates } when length ( candidates ) &gt; 1 -&gt; # Present candidates to user for selection end","ref":"Shippex.html#validate_address/2","title":"Shippex.validate_address/2","type":"function"},{"doc":"","ref":"Shippex.html#t:response/0","title":"Shippex.response/0","type":"type"},{"doc":"Represents an address that can be passed to other Shippex functions. Do not initialize this struct directly. Instead, use address/1 .","ref":"Shippex.Address.html","title":"Shippex.Address","type":"module"},{"doc":"Returns the list of non- nil address lines. If no address_line_2 is present, it returns a list of a single String .","ref":"Shippex.Address.html#address_line_list/1","title":"Shippex.Address.address_line_list/1","type":"function"},{"doc":"Returns the country code for the given common name, or nil if none was found. iex&gt; Address . common_country_code ( &quot;United States&quot; ) &quot;US&quot; iex&gt; Address . common_country_code ( &quot;United States of America&quot; ) &quot;US&quot;","ref":"Shippex.Address.html#common_country_code/1","title":"Shippex.Address.common_country_code/1","type":"function"},{"doc":"Returns a common country name for the given country code. This removes occurrences of &quot;(the)&quot; that may be present in the ISO-3166-2 data. For example, the code &quot;US&quot; normally maps to &quot;United States of America (the)&quot;. We can shorten this with: iex&gt; Address . common_country_name ( &quot;US&quot; ) &quot;United States&quot;","ref":"Shippex.Address.html#common_country_name/1","title":"Shippex.Address.common_country_name/1","type":"function"},{"doc":"Initializes an Address struct from the given params , and performs minor validations that do not require any service requests. You may specify first_name and last_name separately, which will be concatenated to make the name property, or just specify name directly. If name is specified directly, Shippex will try to infer the first and last names in case they're required separately for API calls. Shippex.Address . new ( %{ first_name : &quot;Earl&quot; , last_name : &quot;Grey&quot; , phone : &quot;123-123-1234&quot; , address : &quot;9999 Hobby Lane&quot; , address_line_2 : nil , city : &quot;Austin&quot; , state : &quot;TX&quot; , postal_code : &quot;78703&quot; } )","ref":"Shippex.Address.html#new/1","title":"Shippex.Address.new/1","type":"function"},{"doc":"Calls new/1 and raises an error on failure.","ref":"Shippex.Address.html#new!/1","title":"Shippex.Address.new!/1","type":"function"},{"doc":"Returns true if addresses for the country require a postal code to be specified to validate addresses. iex&gt; Address . postal_code_required? ( &quot;US&quot; ) true iex&gt; Address . postal_code_required? ( &quot;CN&quot; ) true iex&gt; Address . postal_code_required? ( &quot;HK&quot; ) false","ref":"Shippex.Address.html#postal_code_required?/1","title":"Shippex.Address.postal_code_required?/1","type":"function"},{"doc":"Returns the state code without its country code prefix. iex&gt; address = Shippex.Address . new! ( %{ ...&gt; first_name : &quot;Earl&quot; , ...&gt; last_name : &quot;Grey&quot; , ...&gt; phone : &quot;123-123-1234&quot; , ...&gt; address : &quot;9999 Hobby Lane&quot; , ...&gt; address_line_2 : nil , ...&gt; city : &quot;Austin&quot; , ...&gt; state : &quot;US-TX&quot; , ...&gt; postal_code : &quot;78703&quot; , ...&gt; country : &quot;US&quot; ...&gt; } ) iex&gt; Address . state_without_country ( address ) &quot;TX&quot;","ref":"Shippex.Address.html#state_without_country/1","title":"Shippex.Address.state_without_country/1","type":"function"},{"doc":"Returns true if addresses for the country require a province, state, or other subdivision to be specified to validate addresses. iex&gt; Address . subdivision_required? ( &quot;US&quot; ) true iex&gt; Address . subdivision_required? ( &quot;CN&quot; ) true iex&gt; Address . subdivision_required? ( &quot;SG&quot; ) false","ref":"Shippex.Address.html#subdivision_required?/1","title":"Shippex.Address.subdivision_required?/1","type":"function"},{"doc":"","ref":"Shippex.Address.html#t:t/0","title":"Shippex.Address.t/0","type":"type"},{"doc":"Defines a behaviour for implementing a new Carrier module. Includes a helper function for fetching the Carrier module.","ref":"Shippex.Carrier.html","title":"Shippex.Carrier","type":"behaviour"},{"doc":"","ref":"Shippex.Carrier.html#c:cancel_transaction/1","title":"Shippex.Carrier.cancel_transaction/1","type":"callback"},{"doc":"","ref":"Shippex.Carrier.html#c:cancel_transaction/2","title":"Shippex.Carrier.cancel_transaction/2","type":"callback"},{"doc":"","ref":"Shippex.Carrier.html#c:create_transaction/2","title":"Shippex.Carrier.create_transaction/2","type":"callback"},{"doc":"","ref":"Shippex.Carrier.html#c:fetch_rate/2","title":"Shippex.Carrier.fetch_rate/2","type":"callback"},{"doc":"","ref":"Shippex.Carrier.html#c:fetch_rates/1","title":"Shippex.Carrier.fetch_rates/1","type":"callback"},{"doc":"Fetches a Carrier module by its atom/string representation. iex&gt; Carrier . module ( :ups ) Carrier.UPS iex&gt; Carrier . module ( &quot;UPS&quot; ) Carrier.UPS iex&gt; Carrier . module ( &quot;ups&quot; ) Carrier.UPS","ref":"Shippex.Carrier.html#module/1","title":"Shippex.Carrier.module/1","type":"function"},{"doc":"","ref":"Shippex.Carrier.html#c:services_country?/1","title":"Shippex.Carrier.services_country?/1","type":"callback"},{"doc":"","ref":"Shippex.Carrier.html#c:track_packages/1","title":"Shippex.Carrier.track_packages/1","type":"callback"},{"doc":"","ref":"Shippex.Carrier.html#c:validate_address/1","title":"Shippex.Carrier.validate_address/1","type":"callback"},{"doc":"","ref":"Shippex.Carrier.html#t:t/0","title":"Shippex.Carrier.t/0","type":"type"},{"doc":"Defines a struct for storing an Item in a Package . The monetary_value might be required depending on the origin/destination countries of the shipment. Both monetary_value and insurance are integers stored in USD cents.","ref":"Shippex.Item.html","title":"Shippex.Item","type":"module"},{"doc":"Builds and returns an Item . Use this instead of directly initializing the struct.","ref":"Shippex.Item.html#new/1","title":"Shippex.Item.new/1","type":"function"},{"doc":"","ref":"Shippex.Item.html#t:t/0","title":"Shippex.Item.t/0","type":"type"},{"doc":"Defines the struct for storing a returned Rate , along with the tracking number, base64-encoded image and its format. % Shippex.Label { rate : % Shippex.Rate { } , tracking_number : &quot;ABCDEF1234&quot; , format : :gif , image : &quot;iVBORw0K...&quot; } Note that :image is always a pure base64 string, and doesn't contain common prefixes like &quot;data:image/gif;base64,&quot; and so on. Currently, UPS returns GIF labels, and USPS returns PDF labels.","ref":"Shippex.Label.html","title":"Shippex.Label","type":"module"},{"doc":"","ref":"Shippex.Label.html#t:t/0","title":"Shippex.Label.t/0","type":"type"},{"doc":"Defines the struct for storing a Package , which is then passed along with an origin and destination address for shipping estimates. A description is optional, as it may or may not be used with various carriers. For USPS, a package has a container string which can be one of the pre-defined USPS containers. Do not pass a weight parameter. Instead, pass in a list of :items with a weight parameter on each of these. The weight on the package will be the sum of the weights of each of these. Same for :monetary_value . :description can optionally be passed in. Otherwise, it will be generated by joining the descriptions of each of the items. Shippex.Package . package ( %{ length : 8 width : 8 , height : 8 , items : [ %{ weight : 1 , monetary_value : 100 , description : &quot;A&quot; } , %{ weight : 2 , monetary_value : 200 , description : &quot;B&quot; } ] } ) # =&gt; %Package{weight: 3, monetary_value: 300, description: &quot;A, B&quot;, ...}","ref":"Shippex.Package.html","title":"Shippex.Package","type":"module"},{"doc":"Builds and returns a Package . Use this instead of directly initializing the struct.","ref":"Shippex.Package.html#new/1","title":"Shippex.Package.new/1","type":"function"},{"doc":"Returns a map of predefined containers for use with USPS. These can be passed to package.container for fetching rates.","ref":"Shippex.Package.html#usps_containers/0","title":"Shippex.Package.usps_containers/0","type":"function"},{"doc":"Returns a map of flat rate USPS containers, along with their string description and flat shipping rate (in cents).","ref":"Shippex.Package.html#usps_flat_rate_containers/0","title":"Shippex.Package.usps_flat_rate_containers/0","type":"function"},{"doc":"","ref":"Shippex.Package.html#t:t/0","title":"Shippex.Package.t/0","type":"type"},{"doc":"A Rate is a representation of a price estimate from a given carrier for a Service , which is typically selected by the end user for a desired shipping speed.","ref":"Shippex.Rate.html","title":"Shippex.Rate","type":"module"},{"doc":"","ref":"Shippex.Rate.html#t:t/0","title":"Shippex.Rate.t/0","type":"type"},{"doc":"A Service represents a carrier's offered shipping option. This is not initialized by the user directly. However, some convenience functions exist to display all offered carrier services to the user. Service fields are: :id - A unique Shippex ID that can be used to perform lookups or fetch rates :carrier - The atom representing the carrier :code - Internally used by Shippex for API requests :description - A user-friendly string containing the name of the service Example iex&gt; Shippex.Service . services_for_carrier ( :ups ) [ % Shippex.Service { id : :ups_next_day_air , carrier : :ups , description : &quot;UPS Next Day Air&quot; } , % Shippex.Service { id : :ups_second_day_air , carrier : :ups , description : &quot;UPS 2nd Day Air&quot; } , % Shippex.Service { id : :ups_three_day_select , carrier : :ups , description : &quot;UPS 3 Day Select&quot; } , % Shippex.Service { id : :ups_ground , carrier : :ups , description : &quot;UPS Ground&quot; } ]","ref":"Shippex.Service.html","title":"Shippex.Service","type":"module"},{"doc":"Looks up a shipping service by its unique Shippex ID. Returns nil if none exist. iex&gt; Service . get ( :usps_priority ) % Service { id : :usps_priority , carrier : :usps , description : &quot;Priority Mail&quot; } iex&gt; Service . get ( :invalid_service ) nil","ref":"Shippex.Service.html#get/1","title":"Shippex.Service.get/1","type":"function"},{"doc":"Returns all services for carrier based on the shipment provided. Shippex.Service . services_for_carrier ( :ups )","ref":"Shippex.Service.html#services_for_carrier/2","title":"Shippex.Service.services_for_carrier/2","type":"function"},{"doc":"","ref":"Shippex.Service.html#t:t/0","title":"Shippex.Service.t/0","type":"type"},{"doc":"A Shipment represents everything needed to fetch rates from carriers: an origin, a destination, and a package description. An optional :id field is provided in the struct, which may be used by the end user to represent the user's internal identifier for the shipment. The id is not used by Shippex. Shipments are created by shipment/3 .","ref":"Shippex.Shipment.html","title":"Shippex.Shipment","type":"module"},{"doc":"Builds a Shipment .","ref":"Shippex.Shipment.html#new/4","title":"Shippex.Shipment.new/4","type":"function"},{"doc":"Builds a Shipment . Raises on failure.","ref":"Shippex.Shipment.html#new!/4","title":"Shippex.Shipment.new!/4","type":"function"},{"doc":"","ref":"Shippex.Shipment.html#t:t/0","title":"Shippex.Shipment.t/0","type":"type"},{"doc":"Defines a struct that represents billable transactions with carriers.","ref":"Shippex.Transaction.html","title":"Shippex.Transaction","type":"module"},{"doc":"","ref":"Shippex.Transaction.html#t:t/0","title":"Shippex.Transaction.t/0","type":"type"},{"doc":"","ref":"Shippex.InvalidConfigError.html","title":"Shippex.InvalidConfigError","type":"exception"},{"doc":"Shippex Shippex is an abstraction of commonly used features in shipping with various carriers. It provides a (hopefully) pleasant API to work with carrier-provided web interfaces for fetching rates and printing shipping labels. As of now, only UPS and USPS are supported. More carrier support will come in the future. Units of measurement are mostly hardcoded to inches and miles.","ref":"readme.html","title":"Shippex","type":"extras"},{"doc":"Add shippex to your list of dependencies in mix.exs : def deps do [ { :shippex , &quot;~&gt; 0.14&quot; } ] end Ensure shippex is started before your application: def application do [ applications : [ :shippex ] ] end","ref":"readme.html#installation","title":"Shippex - Installation","type":"extras"},{"doc":"config :shippex , env : :dev , distance_unit : :in , # either :in or :cm weight_unit : :lbs , # either :lbs or :kg currency : :usd , # :usd, :can, :mxn, :eur carriers : [ ups : [ username : &quot;MyUsername&quot; , password : &quot;MyPassword&quot; , secret_key : &quot;123123&quot; , shipper : %{ account_number : &quot;AB1234&quot; , name : &quot;My Company&quot; , phone : &quot;123-456-7890&quot; , address : &quot;1234 Foo St&quot; , city : &quot;Foo&quot; , state : &quot;TX&quot; , postal_code : &quot;78999&quot; } ] , usps : [ username : &quot;MyUsername&quot; , password : &quot;MyPassword&quot; ] ]","ref":"readme.html#configuration","title":"Shippex - Configuration","type":"extras"},{"doc":"# Create origin/destination addresses. origin = Shippex.Address . new ( %{ name : &quot;Earl G&quot; , phone : &quot;123-123-1234&quot; , address : &quot;9999 Hobby Lane&quot; , address_line_2 : nil , city : &quot;Austin&quot; , state : &quot;TX&quot; , postal_code : &quot;78703&quot; } ) destination = Shippex.Address . new ( %{ name : &quot;Bar Baz&quot; , phone : &quot;123-123-1234&quot; , address : &quot;1234 Foo Blvd&quot; , address_line_2 : nil , city : &quot;Plano&quot; , state : &quot;TX&quot; , postal_code : &quot;75074&quot; , country : &quot;US&quot; # optional } ) # Create a package. Currently only inches and pounds (lbs) supported. package = Shippex.Package . new ( %{ length : 8 , width : 8 , height : 4 , weight : 5 , description : &quot;Headphones&quot; , monetary_value : 20 # optional } ) # Link the origin, destination, and package with a shipment. shipment = Shippex.Shipment . new ( origin , destination , package ) # Fetch rates to present to the user. rates = Shippex . fetch_rates ( shipment , carriers : :usps ) # Accept one of the services and print the label { :ok , rate } = Enum . shuffle ( rates ) |&gt; hd # Fetch the label. Includes the tracking number and a gif image of the label. { :ok , transaction } = Shippex . create_transaction ( shipment , rate . service ) rate = transaction . rate label = transaction . label # Print the price. IO . puts ( rate . price ) # Write the label to disk. File . write! ( &quot; \#{ label . tracking_number } . \#{ label . format } &quot; , Base . decode64! ( label . image ) )","ref":"readme.html#usage","title":"Shippex - Usage","type":"extras"},{"doc":"Carrier support: [x] UPS [x] USPS [ ] FedEx","ref":"readme.html#todo","title":"Shippex - TODO:","type":"extras"}]